Vue.js Drupal module
====================

DESCRIPTION
-----------

The module provides a bridge between Drupal and Vue.js framework.

REQUIREMENTS
------------

- Drupal 9.x or 8.9.x
- Drush 10.x or - for Drupal 8.x only - Drush 9.x
- PHP 7.2 or higher
- The `vuejs:download` Drush command needs [`wget(1)`]

[`wget(1)`]: https://www.gnu.org/software/wget/


CONFIGURATION
-------------

Navigate to the `admin/config/development/vuejs` page and set up desired
versions of the libraries.

LIBRARY DOWNLOAD (LOCAL)
-------------

# Local library (manual download or via drush):
Note if you prefer installing libraries locally you
need to install them after each version change. The following Drush command can
be used to quickly download required Vue.js libraries:

```
drush vuejs:download <LIBRARY_NAME>
```

Downloadable libraries are: `vue`, `vue-router`, and `vue-resource`.
Alternatively, you can download them manually from the path on the settings page
and place them in libraries/vuejs/<LIBRARY_NAME>/<VERSION>/<LIBRARY_NAME>(.min).js

# Local via Composer (Asset Packagist: NPM):
Download libraries by
```
'composer require npm-asset/vue:<VERSION>
npm-asset/vue-resource:<VERSION> npm-asset/vue-router:<VERSION>'
```
to libraries/<LIBRARY_NAME>/dist/<LIBRARY_NAME>(.min).js.
See https://www.drupal.org/docs/develop/using-composer/using-composer-to-install-drupal-and-manage-dependencies#third-party-libraries
for details.

# Local via Composer (Asset Packagist: Bower):
Download libraries by
```
'composer require bower-asset/vue:<VERSION>
bower-asset/vue-resource:<VERSION> bower-asset/vue-router:<VERSION>'
```
to libraries/<LIBRARY_NAME>/dist/<LIBRARY_NAME>(.min).js.
See https://www.drupal.org/docs/develop/using-composer/using-composer-to-install-drupal-and-manage-dependencies#third-party-libraries
for details.

HOW TO USE
----------

1. You can use inside Twig templates as usual, for example:
```twig
{{ attach_library('vuejs/vue') }}
```
2. You can attach it programmatically:
```php
function MYMODULE_page_attachments(array &$attachments) {
  $attachments['#attached']['library'][] = 'vuejs/vue';
}
```
3. You can add it as a dependency inside your `*.libraries.yml`:
```yaml
  dependencies:
    - vuejs/vue
    - vuejs/vue_router
    - vuejs/vue_resource
```

PROJECT PAGE
------------

https://www.drupal.org/project/vuejs
